// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : D.Yamaguchi
//    : 2005/11/25 
//
//-------------------------------------------------------------------

// xyq_subDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "xyq_sub.h"
#include "xyq_subDlg.h"
#include "LicenseDlg.h"
#include "ConfFileDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace
{
	const double PI = 3.14159265358979;
}

extern CXyq_subApp theApp;

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXyq_subDlg _CAO

CXyq_subDlg::CXyq_subDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CXyq_subDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CXyq_subDlg)
	m_Condition = 5;
	m_ScoreThresh = 60;
	m_ScoreThresh2 = 50;
	m_WindowTouch = FALSE;
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CXyq_subDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXyq_subDlg)
	DDX_Control(pDX, IDC_RESULT, m_Result);
	DDX_Control(pDX, IDC_PRECISION, m_Precision);
	DDX_Control(pDX, IDC_SEARCHMODE, m_SearchMode);
	DDX_Text(pDX, IDC_CONDITION, m_Condition);
	DDV_MinMaxLong(pDX, m_Condition, 1, 9);
	DDX_Text(pDX, IDC_SCORETHRESH, m_ScoreThresh);
	DDV_MinMaxLong(pDX, m_ScoreThresh, 10, 99);
	DDX_Text(pDX, IDC_SCORETHRESH2, m_ScoreThresh2);
	DDV_MinMaxLong(pDX, m_ScoreThresh2, 10, 99);
	DDX_Check(pDX, IDC_WINDOWTOUCH, m_WindowTouch);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CXyq_subDlg, CDialog)
	//{{AFX_MSG_MAP(CXyq_subDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadImage)
	ON_BN_CLICKED(IDC_EXEREGION, OnExeRegion)
	ON_BN_CLICKED(IDC_SETPATTERN_1, OnSetPatternClicked_1)
	ON_BN_CLICKED(IDC_SETMASK_1, OnSetMask1)
	ON_BN_CLICKED(IDC_DISPPATTERN_1, OnDispPattern1)
	ON_BN_CLICKED(IDC_LOADPATTERN_1, OnLoadPatternClicked_1)
	ON_BN_CLICKED(IDC_SAVEPATTERN_1, OnSavePatternClicked_1)
	ON_BN_CLICKED(IDC_SETPATTERN_2, OnSetPatternClicked_2)
	ON_BN_CLICKED(IDC_SETMASK_2, OnSetMask_2)
	ON_BN_CLICKED(IDC_DISPPATTERN_2, OnDispPattern2)
	ON_BN_CLICKED(IDC_LOADPATTERN_2, OnLoadPatternClicked_2)
	ON_BN_CLICKED(IDC_SAVEPATTERN_2, OnSavePatternClicked_2)
	ON_BN_CLICKED(IDC_SET_SUBRECT, OnSet_SubRect)
	ON_BN_CLICKED(IDC_SETSTANDARD, OnSetStandard)
	ON_BN_CLICKED(IDC_EXECUTE, OnExecute)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_DOSAMPLE, OnDosample)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXyq_subDlg bZ[W nh

BOOL CXyq_subDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	
	CString strErr;

	// COM
	CoInitialize( NULL );
	CWnd *pWnd, *pWndGrabButton;
	IUnknown *p_Unknown;

	// Dialogɓ\tFvxDisplayRg[̎̂擾
	pWnd = this->GetDlgItem( IDC_FVXDISPLAYEX1 );
	p_Unknown = pWnd->GetControlUnknown();
	p_Unknown->QueryInterface( __uuidof( IFvxDisplayEx2Ptr ), (void**)&m_FvxDisplayEx );

	// Rg[̃CX^X̐
	m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) );
	m_FvxROI.CreateInstance( __uuidof( FvxROI ) );
	m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) );
	m_FvxPattern.CreateInstance( __uuidof( FvxPattern ) );
	m_FvxPattern2.CreateInstance( __uuidof( FvxPattern ) );
	m_FvxImage.CreateInstance( __uuidof( FvxImage ) );
	m_FvxImageStandard.CreateInstance( __uuidof( FvxImage ) );
	m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) );
	m_FvxCorrelation.CreateInstance( __uuidof( FvxCorrelation ) );
	m_FvxCalcData.CreateInstance( __uuidof( FvxCalcData ) );
	m_FvxPaintOnImage.CreateInstance( __uuidof( FvxPaintOnImage ) );
	m_ExeRegion.CreateInstance( __uuidof( FvRectangle ) );
	m_SubRegion.CreateInstance( __uuidof( FvRectangle ) );
	m_StandardPoint.CreateInstance( __uuidof( FvPoint ) );
	
	// ݒpRg[̏
	m_SearchMode.AddString( "ʏ̃p^[" );
	m_SearchMode.AddString( "̃p^[" );
	m_SearchMode.AddString( "̃p^[" );
	m_SearchMode.AddString( "sp^[" );
	m_SearchMode.SetCurSel( 0 );

	m_Precision.AddString( "ʏ퐸x" );
	m_Precision.AddString( "x" );
	m_Precision.AddString( "x" );
	m_Precision.SetCurSel( 0 );

	m_blnVideoOpened = FALSE;
	pWndGrabButton = this->GetDlgItem( IDC_GRAB );
	pWndGrabButton->EnableWindow( FALSE );

	LicenseDlg ldlg;
	CConfFileDlg fdlg;

	// gp̊mF
	if( IDOK == ldlg.DoModal() )
	{
		// rfIݒt@C̑I
		fdlg.DoModal();

		if( FALSE == fdlg.m_check )
		{
			try
			{
				// rfIݒt@CR|[lgɐݒ
				m_FvxVideo->PutVideoConfFile( (_bstr_t)fdlg.m_conffile );

				// rfIfoCXI[v
				m_FvxVideo->OpenDevice();
				m_blnVideoOpened = TRUE;

				// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
				// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
				// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
				// g̃Lv`{[hɍ킹ĕύXĂB
				::Sleep( 350 );

				// GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
				// 炩ChangeImageSize\bhɂImagẽTCYύXĂ
				//i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
				m_FvxVideo->ChangeImageSize( m_FvxImage );

				try
				{
					// 捞
					m_FvxVideo->GrabSync( m_FvxImage );
					pWndGrabButton->EnableWindow( TRUE );
				}
				catch( _com_error )
				{
					strErr.Format( "rfI̎荞݂Ɏs܂\n摜t@Ĉ݂̗pɂȂ܂B" );
					::AfxMessageBox( strErr, MB_ICONWARNING | MB_OK );
				}
			}
			catch( _com_error )
			{
				strErr.Format( "rfIfoCX̃I[vɎs܂\n摜t@Ĉ݂̗pɂȂ܂B" );
				::AfxMessageBox( strErr, MB_ICONWARNING | MB_OK );
			}
		}
	}
	else
	{
		// ӂĂ炦Ȃ瑦I
		this->EndDialog( IDCANCEL );
	}

	// ʂ̐
	m_FvxDisplayEx->CreateDisplay( 1, 0 );

	// 摜̕\
	m_FvxDisplayEx->DrawImage( m_FvxImage );

	// ͈͂̏lݒ(摜̑Sʂɐݒj
	m_ExeRegion->Putxs( -1 );
	m_ExeRegion->Putys( -1 );
	m_ExeRegion->Putxe( -1 );
	m_ExeRegion->Putye( -1 );

	// Z̈̏lݒ
	m_SubRegion->Putxs( 100 );
	m_SubRegion->Putys( 100 );
	m_SubRegion->Putxe( 200 );
	m_SubRegion->Putye( 200 );

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CXyq_subDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CXyq_subDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CXyq_subDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CXyq_subDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ

	// rfIfoCXI[vĂꍇ̓N[Y܂
	if( TRUE == m_blnVideoOpened )
	{
		m_FvxVideo->CloseDevice();
	}
}

void CXyq_subDlg::OnGrab() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	// 摜t@Cǂݍ݂ɂāA摜TCY
	// ύXĂ\邽߁AChangeImageSizes܂B
	// 摜TCYύX\ꍇ́AɈxsΖL܂B
	m_FvxVideo->ChangeImageSize( m_FvxImage );
	
	// 捞
	m_FvxVideo->GrabSync( m_FvxImage );

	// 荞񂾉摜ʂɕ\
	m_FvxDisplayEx->DrawImage( m_FvxImage );

}

void CXyq_subDlg::OnLoadImage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	// R_CAONX̐
	char szFilters[] = "bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName( GetModuleHandle(NULL), szIniFilePath, _MAX_PATH );
	// _CAOɂĉ摜t@CI܂
	CFileDialog fdlg( TRUE, "bmp", NULL, OFN_PATHMUSTEXIST|OFN_HIDEREADONLY, szFilters, this );
	fdlg.m_ofn.lpstrInitialDir = szIniFilePath;
	fdlg.m_ofn.lpstrTitle = "摜t@Cǂݍ";

	if( IDOK == fdlg.DoModal() )
	{
		try
		{
			// FileAccessR|[lgpăt@CImageɉ摜ǂݍ݂܂
			m_FvxFileAccess->PutFilePath( _bstr_t( fdlg.GetPathName() ) );
			m_FvxFileAccess->LoadBitmap( m_FvxImage );
		}
		catch( _com_error )
		{
			long lErr;
			CString cStr;

			// G[ԍ擾
			m_FvxFileAccess->GetErrReport( &lErr );
			cStr.Format( "Ǎ݂Ɏs܂Berr_no = %ld", lErr );
			::AfxMessageBox( cStr, MB_ICONWARNING | MB_OK );
			return;
		}
	}

	// 摜^Cv`FbN
	if( imageGray != m_FvxImage->GetImageType() )
	{
		::AfxMessageBox( "OC摜ł͂܂", MB_ICONWARNING | MB_OK );

        m_FvxImage->PutBitPerPixel( 8 );
        m_FvxImage->PutImageType( imageGray );
        m_FvxImage->PutImageWidth( 512 );
        m_FvxImage->PutImageHeight( 480 );
	}

	m_FvxDisplayEx->DrawImage( m_FvxImage );
}

void CXyq_subDlg::OnExeRegion() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	long lOkCancel;
	double dXs, dYs, dXe, dYe;

	m_FvxROI->SetRectangle( m_ExeRegion );

	// FvxROIgď͈͑I_CAOo܂
	m_FvxROI->PutUsePoint( FALSE );
	m_FvxROI->MakeROIDialog( m_FvxImage, &lOkCancel );

	if( 1 == lOkCancel && 1 == m_FvxROI->GetCheckRectangle() )
	{
		m_FvxROI->GetRectangle( m_ExeRegion );

		// n_ƏI_tɂȂĂȂ`FbN܂
		// FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
		// tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ

		dXs = m_ExeRegion->Getxs();
		dYs = m_ExeRegion->Getys();
		dXe = m_ExeRegion->Getxe();
		dYe = m_ExeRegion->Getye();

		if( dXe < dXs )
		{
			m_ExeRegion->Putxs( dXe );
			m_ExeRegion->Putxe( dXs );
		}

		if( dYe < dYs )
		{
			m_ExeRegion->Putys( dYe );
			m_ExeRegion->Putye( dYs );
		}
	}

}

void CXyq_subDlg::SetPattern( int iPatternNum )
{
	IFvRectangle2Ptr pRect( __uuidof( FvRectangle ) );
	IFvPointPtr pPoint( __uuidof( FvPoint ) );

	long lOkCancel;
	double dXs, dYs, dXe, dYe;

	// o^̏`ݒ
	m_FvxROI->InitPoint();
	m_FvxROI->InitRectangle();
	pRect->Putxs( 100 );
	pRect->Putys( 100 );
	pRect->Putxe( 200 );
	pRect->Putye( 200 );
	m_FvxROI->SetRectangle( pRect );

	// FvxROIgď͈͑I_CAOo܂
	m_FvxROI->MakeROIDialog( m_FvxImage, &lOkCancel );

	if( 1 == lOkCancel && 1 == m_FvxROI->GetCheckRectangle() )
	{
		m_FvxROI->GetRectangle( pRect );

		// n_ƏI_tɂȂĂȂ`FbN܂
		// FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
		// tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ

		dXs = pRect->Getxs();
		dYs = pRect->Getys();
		dXe = pRect->Getxe();
		dYe = pRect->Getye();

		if( dXe < dXs )
		{
			pRect->Putxs( dXe );
			pRect->Putxe( dXs );
		}

		if( dYe < dYs )
		{
			pRect->Putys( dYe );
			pRect->Putye( dYs );
		}

		if( 1 == m_FvxROI->GetCheckPoint() )
		{
			m_FvxROI->GetPoint( pPoint );
		}
		else
		{
			::AfxMessageBox( "p^[_w肳܂łB\np^[`̒S_Ƃēo^܂" );

			dXs = pRect->Getxs();
			dYs = pRect->Getys();
			dXe = pRect->Getxe();
			dYe = pRect->Getye();

			pPoint->Putx( (dXs + dXe) / 2 );
			pPoint->Puty( (dYs + dYe) / 2 );
		}

		switch( iPatternNum )
		{
			case 1:
				m_FvxPattern->MakePattern( m_FvxImage, pRect, pPoint );
				break;
			case 2:
				m_FvxPattern2->MakePattern( m_FvxImage, pRect, pPoint );
				break;
		}
	}

}

void CXyq_subDlg::OnSetPatternClicked_1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	SetPattern( 1 );
}

void CXyq_subDlg::OnSetMask1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	m_FvxPattern->DefMask( 100, 100 );
}

void CXyq_subDlg::OnDispPattern1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	m_FvxPattern->Disp( 100, 100 );

}

void CXyq_subDlg::LoadPattern( int iPatternNum )
{
	// p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
	// "pat"gp邱Ƃ𐄏܂

	// R_CAONX̐
	char szFilters[] = "ptn file(*.ptn)|*.ptn||";
	char szPtnFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName( GetModuleHandle(NULL), szPtnFilePath, _MAX_PATH );
	// _CAOɂăp^t@CI܂
	CFileDialog fdlg( TRUE, "ptn", NULL, OFN_PATHMUSTEXIST|OFN_HIDEREADONLY, szFilters, this );
	fdlg.m_ofn.lpstrInitialDir = szPtnFilePath;
	fdlg.m_ofn.lpstrTitle = "p^t@Cǂݍ";

	if( IDOK == fdlg.DoModal() )
	{
		try
		{
			switch( iPatternNum )
			{
				case 1:
					m_FvxPattern->PutLoadPattrenFileName( _bstr_t( fdlg.GetPathName() ) );
					m_FvxPattern->Load();
					break;
				case 2:
					m_FvxPattern2->PutLoadPattrenFileName( _bstr_t( fdlg.GetPathName() ) );
					m_FvxPattern2->Load();
					break;
			}
		}
		catch( _com_error )
		{
			::AfxMessageBox( "p^t@C̓Ǎ݂Ɏs܂B", MB_ICONWARNING | MB_OK );
			return;
		}
	}

}

void CXyq_subDlg::OnLoadPatternClicked_1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	LoadPattern( 1 );
}

void CXyq_subDlg::SavePattern( int iPatternNum )
{
	// R_CAONX̐
	char szFilters[] = "ptn file(*.ptn)|*.ptn||";
	char szPtnFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName( GetModuleHandle(NULL), szPtnFilePath, _MAX_PATH );
	CFileDialog fdlg( FALSE, "ptn", NULL, OFN_PATHMUSTEXIST|OFN_HIDEREADONLY, szFilters, this );
	fdlg.m_ofn.lpstrInitialDir = szPtnFilePath;
	fdlg.m_ofn.lpstrTitle = "p^t@Cۑ";

	if( IDOK == fdlg.DoModal() )
	{
		try
		{
			switch( iPatternNum )
			{
				case 1:
					m_FvxPattern->PutSavePattrenFileName( _bstr_t( fdlg.GetPathName() ) );
					m_FvxPattern->Save();
					break;
				case 2:
					m_FvxPattern2->PutSavePattrenFileName( _bstr_t( fdlg.GetPathName() ) );
					m_FvxPattern2->Save();
					break;
			}
		}
		catch( _com_error )
		{
			::AfxMessageBox( "p^t@C̕ۑɎs܂B", MB_ICONWARNING | MB_OK );
			return;
		}
	}

}

void CXyq_subDlg::OnSavePatternClicked_1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	SavePattern( 1 );
}

void CXyq_subDlg::OnSetPatternClicked_2() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	SetPattern( 2 );
}

void CXyq_subDlg::OnSetMask_2() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	m_FvxPattern2->DefMask( 100, 100 );

}

void CXyq_subDlg::OnDispPattern2() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	m_FvxPattern2->Disp( 100, 100 );
}

void CXyq_subDlg::OnLoadPatternClicked_2() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	LoadPattern( 2 );
}

void CXyq_subDlg::OnSavePatternClicked_2() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	SavePattern( 2 );
}

void CXyq_subDlg::OnSet_SubRect() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	long lOkCancel;
	double dXs, dYs, dXe, dYe;

	m_FvxROI->SetRectangle( m_SubRegion );

	// FvxROIgď͈͑I_CAOo܂
	m_FvxROI->PutUsePoint( FALSE );
	m_FvxROI->MakeROIDialog( m_FvxImage, &lOkCancel );

	if( 1 == lOkCancel && 1 == m_FvxROI->GetCheckRectangle() )
	{
		m_FvxROI->GetRectangle( m_SubRegion );

		// n_ƏI_tɂȂĂȂ`FbN܂
		// FvxROI͋`f[^ŁAEE̍Wʒu(xs > xe, ys > ye)
		// tɂȂĂꍇłAւ̂܂܌ʂԂ܂̂ŁAӂĂ

		dXs = m_SubRegion->Getxs();
		dYs = m_SubRegion->Getys();
		dXe = m_SubRegion->Getxe();
		dYe = m_SubRegion->Getye();

		if( dXe < dXs )
		{
			m_SubRegion->Putxs( dXe );
			m_SubRegion->Putxe( dXs );
		}

		if( dYe < dYs )
		{
			m_SubRegion->Putys( dYe );
			m_SubRegion->Putye( dYs );
		}
	}

	// Z̈\
    m_FvxDisplayEx->PutPenColor( RGB(192, 192, 255) );
    m_FvxDisplayEx->DrawData( 0, m_SubRegion );

}

int CXyq_subDlg::ApplyChanges()
{
	int iStatus = -1;

	// DDX͈̓`FbN
	if( 0 == this->UpdateData( TRUE ) ) return iStatus;

	// p[^ݒ
	m_FvxCorrelation->SetInspectArea( m_ExeRegion );// ͈
	m_FvxCorrelation->PutSearchMode( static_cast<FVXCOMLib::SEARCH_MODE_TYPE>( m_SearchMode.GetCurSel() ) );// T[`[h
	m_FvxCorrelation->PutPrecision( static_cast<FVXCOMLib::PRECISION_TYPE>( m_Precision.GetCurSel() ) );// T[`
	m_FvxCorrelation->PutScoreThresh( m_ScoreThresh );
	m_FvxCorrelation->PutScoreThresh2( m_ScoreThresh2 );
	m_FvxCorrelation->PutCondition( m_Condition );

	// T[`
	m_FvxCorrelation->PutSearchNum( 1 );

	// ͈͐ڐGĂ̂o邩
	if( TRUE == CXyq_subDlg::m_WindowTouch )
	{
		m_FvxCorrelation->PutWindowTouch( static_cast<FVXCOMLib::WINDOW_TOUCH_TYPE>( 1 ) );
	}
	else
	{
		m_FvxCorrelation->PutWindowTouch( static_cast<FVXCOMLib::WINDOW_TOUCH_TYPE>( 0 ) );
	}

	// G[
	iStatus = 0;

	return iStatus;
}

// Q̓o^p^[ɂāAT[`s
// Ԓl  I = 0, ُI(p^[Ȃetc) = -1
int CXyq_subDlg::Search( IFvSearchResultPtr pSearch_0, IFvSearchResultPtr pSearch_1 )
{
	int iStatus = -1;
	long lCount, lErr;
	CString GetCorrelationErrMesg;

	// p^[PT[`s
	try
	{
		m_FvxCorrelation->SetPattern( m_FvxPattern );
		m_FvxCorrelation->Execute( m_FvxImage, &lCount );
    
		if( 1 == lCount )
		{
			m_FvxCorrelation->GetResult( 0, pSearch_0 );

			// p^[QT[`s
			m_FvxCorrelation->SetPattern( m_FvxPattern2 );
			m_FvxCorrelation->Execute( m_FvxImage, &lCount );

			if( 1 == lCount )
			{
				m_FvxCorrelation->GetResult( 0, pSearch_1 );

				// p^[QƂԒl = 0
				iStatus = 0;
			}
			else
			{
				::AfxMessageBox( "p^[Q܂" );
			}
		}
		else
		{
			::AfxMessageBox( "p^[P܂" );
		}
	}
	catch( _com_error )
	{
		m_FvxCorrelation->GetErrReport( &lErr );
		switch( lErr )
		{
			case 0:
				GetCorrelationErrMesg = "G[";
			case 5001:
				GetCorrelationErrMesg = "p^݂Ă܂B";
			case 5005:
				GetCorrelationErrMesg = "p[^Ⴂ܂B";
			case 5006:
				GetCorrelationErrMesg = "^Ⴂ܂B";
			case 5007:
				GetCorrelationErrMesg = "p^摜̂߁Ao^ł܂B";
			case 5008:
				GetCorrelationErrMesg = "p^ƃ}XÑTCYvĂ܂B";
			case 5009:
				GetCorrelationErrMesg = "p[^NULLlw肳܂B";
			case 5010:
				GetCorrelationErrMesg = "̊mۂɎs܂B";
			case 5022:
				GetCorrelationErrMesg = "p^w肳Ă܂B";
			default:
				GetCorrelationErrMesg = "sȃG[";
		}

		::AfxMessageBox( GetCorrelationErrMesg );
	}

	return iStatus;
}

// -΁`΂܂ŌvZł悤Atng
double CXyq_subDlg::ArcTan( double dX, double dY )
{
	double iStatus = 0;

	if( dX > 0 )
	{
		iStatus = atan( dY / dX );
	}
	else
	{
		if( dY > 0 )
		{
			iStatus = PI - atan( dY / -dX ); 
		}
		else
		{
			iStatus = atan( -dY / -dX ) - PI;
		}
	}

	return iStatus;
}

void CXyq_subDlg::DrawPointMark( IFvPointPtr pPoint )
{
	IFvRectangle2Ptr pBox( __uuidof( FvRectangle ) );
	IFvLineSegmentPtr pLineSeg( __uuidof( FvLineSegment ) );

	double dX, dY;

	dX = pPoint->Getx();
	dY = pPoint->Gety();

	pBox->Putxs( dX - 3 );
	pBox->Putys( dY - 3 );
	pBox->Putxe( dX + 3 );
	pBox->Putye( dY + 3 );
	m_FvxDisplayEx->DrawData( 0, pBox );

	pLineSeg->Putxs( dX - 8 );
	pLineSeg->Putxe( dX + 8 );
	pLineSeg->Putys( dY );
	pLineSeg->Putye( dY );
	m_FvxDisplayEx->DrawData( 0, pLineSeg );

	pLineSeg->Putxs( dX );
	pLineSeg->Putxe( dX );
	pLineSeg->Putys( dY - 8 );
	pLineSeg->Putye( dY + 8 );
	m_FvxDisplayEx->DrawData( 0, pLineSeg );

}

void CXyq_subDlg::OnSetStandard() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	IFvSearchResultPtr pSearch_0( __uuidof( FvSearchResult ) );
	IFvSearchResultPtr pSearch_1( __uuidof( FvSearchResult ) );
	IFvLinePtr pLine( __uuidof( FvLine ) );

	CString strResult;
	double dX_0, dY_0, dX_1, dY_1;

	m_FvxDisplayEx->ClearOverlay( 0 );

	// ep[^̓Kp
	if( -1 == ApplyChanges() ) return;

	if( 0 == Search( pSearch_0, pSearch_1 ) )
	{
		// ͈͂ŕ\
		m_FvxDisplayEx->PutPenColor( RGB(0, 0, 255) );
		m_FvxDisplayEx->DrawData( 0, m_ExeRegion );

		// T[`ʂ͐Ԃŕ\
		m_FvxDisplayEx->PutPenColor( RGB(255, 0, 0) );

		m_FvxDisplayEx->DrawData( 0, pSearch_0 );
		m_FvxDisplayEx->DrawData( 0, pSearch_1 );

		// Q̃T[`ʂ̒_ƁAxƂ̌p߂
		dX_0 = pSearch_0->Getx();
		dY_0 = pSearch_0->Gety();
		dX_1 = pSearch_1->Getx();
		dY_1 = pSearch_1->Gety();

		m_StandardPoint->Putx( ( dX_0 + dX_1 ) / 2 );
		m_StandardPoint->Puty( ( dY_0 + dY_1 ) / 2 );
		// px߂ۂɁAW͉Ɍƒl傫Ȃ邱ƂɒӂĂ
		// ̂߁A̒l͉EŐɂȂ܂B
		m_dStandardAngle = ArcTan( (dX_1 - dX_0), (dY_1 - dY_0) );

		m_FvxDisplayEx->PutPenColor( RGB(0, 0, 255) );
		DrawPointMark( m_StandardPoint );

		// FvxCalcDataR|[lg𗘗pāA
		// _ʂ钼̎߂
		m_FvxCalcData->CalcLine_TwoPoint( pSearch_0, pSearch_1 );
		m_FvxCalcData->CalcLine_GetResult( pLine );

		m_FvxDisplayEx->DrawData( 0, pLine );

		// Z̈\
		m_FvxDisplayEx->PutPenColor( RGB(192, 192, 255) );
		m_FvxDisplayEx->DrawData( 0, m_SubRegion );

		// 摜ۑ
		m_FvxImage->CopyTo( m_FvxImageStandard );

		strResult.Format( "w  %.2f\r\nx  %.2f\r\npx  %.2f\r\n",
						   m_StandardPoint->Getx(), m_StandardPoint->Gety(), m_dStandardAngle * 180 / PI );
		m_Result.SetWindowText( strResult );
	}

}

// 摜i]{sړ̍Wnj(x1,y)(x2,y)܂ł̌ZȂ܂
void CXyq_subDlg::LineSubtract( long y, long x1, long x2, double DiffX, double DiffY, double DiffAngle )
{
	int st;
	long i;
	IFvPointPtr pCenter( __uuidof( FvPoint ) );// sړ̍Wnł́A]S
	IFvPointPtr pPoint( __uuidof( FvPoint ) );// 摜̍W
	IFvPointPtr pOrgPoint( __uuidof( FvPoint ) );// 摜̍W
	long lNow;// 摜̍WpPointɂZxl
	long lOrg;// 摜̍WpOrgPointɂZxl
	double dX, dY;
	double dPX, dPY;
	BOOL bFlag;

	// ]{sړ̕⏕ϐ
	double dSin;
	double dCos;
	double dTmpX;
	double dTmpY;


	// YWNbsO
	if( y < 0 || y >= m_FvxImage->GetImageWidth() ) return;

	// ACgsA]{sړ̍Wn
	// ]{sړO̊摜̍Wnɕϊ
	pCenter->Putx( m_StandardPoint->Getx() + DiffX );
	pCenter->Puty( m_StandardPoint->Gety() + DiffY );
	dSin = sin( DiffAngle );
	dCos = cos( DiffAngle );

	dX = pCenter->Getx();
	dY = pCenter->Gety();

	dTmpX = (dX * (1 - dCos)) + (dY * dSin) - DiffX;
	dTmpY = -(dX * dSin) + (dY * (1 - dCos)) - DiffY;

	pPoint->Puty( y );

	if( x1 < x2 )
	{
		st = 1;
	}
	else
	{
		st = -1;
	}

	bFlag = FALSE;
	for( i = x1; FALSE == bFlag; i = (i + st) )
	{
		if( i == x2 ) 
		{
			bFlag = TRUE;
		}

		pPoint->Putx( i );

		dPX = pPoint->Getx();
		dPY = pPoint->Gety();

		pOrgPoint->Putx( (dPX * dCos) - (dPY * dSin) + dTmpX );
		pOrgPoint->Puty( (dPX * dSin) + (dPY * dCos) + dTmpY );

		// XWNbsO
		if( !(i < 0 || m_FvxImage->GetImageWidth() <= i) )
		{
			m_FvxImage->GetPixel( pPoint, &lNow, 0 );
			m_FvxImageStandard->GetPixel( pOrgPoint, &lOrg, 0 );
			m_FvxPaintOnImage->PutDensity( static_cast<FVXCOMLib::DENSITY_TYPE>(abs(lNow - lOrg)) );
			m_FvxPaintOnImage->Paint( m_FvxImage, pPoint );
		}
	}

}

void CXyq_subDlg::Subtract( double DiffX, double DiffY, double DiffAngle )
{
	double dSin, dCos, dTmpX, dTmpY;
	long lX[4];
	long lY[4];
	double dX, dY;
	long lTmp;
	long i, j;
	long x1, x2;
	IFvLineSegmentPtr pLine( __uuidof( FvLineSegment ) );
	size_t szLong, szlX_Total, szlY_Total;
	int ilX_Num, ilY_Num;
	
	// Zs`̈
	lX[0] = static_cast<long>(m_SubRegion->Getxs());// 
	lY[0] = static_cast<long>(m_SubRegion->Getys());
	lX[1] = static_cast<long>(m_SubRegion->Getxs());// 
	lY[1] = static_cast<long>(m_SubRegion->Getye());
	lX[2] = static_cast<long>(m_SubRegion->Getxe());// E
	lY[2] = static_cast<long>(m_SubRegion->Getys());
	lX[3] = static_cast<long>(m_SubRegion->Getxe());// E
	lY[3] = static_cast<long>(m_SubRegion->Getye());

	// `̍W_YɊÂăACg
	dX = m_StandardPoint->Getx();
	dY = m_StandardPoint->Gety();

	dSin = sin( -DiffAngle );
	dCos = cos( -DiffAngle );
	dTmpX = (dX * (1 - dCos)) + (dY * dSin) + DiffX;
	dTmpY = -(dX * dSin) + (dY * (1 - dCos)) + DiffY;

	for( i = 0; i <= 3; i++ )
	{
		lTmp = static_cast<long>((lX[i] * dCos) - (lY[i] * dSin) + dTmpX);
		lY[i] = static_cast<long>((lX[i] * dSin) + (lY[i] * dCos) + dTmpY);
		lX[i] = lTmp;
	}

	szLong = sizeof( long );
	szlX_Total = sizeof( lX );
	szlY_Total = sizeof( lY );
	ilX_Num = szlX_Total / szLong;
	ilY_Num = szlY_Total / szLong;

	// W̑傫ɍW_בւ
	for( i = 0; i < ilY_Num; i++ )
	{
		for( j = ilY_Num - 1; j >= i + 1; j-- )
		{
			if( lY[j - 1] > lY[j] || (lY[j - 1] == lY[j] && lX[j - 1] > lX[j]))
			{
				lTmp = lY[j];
				lY[j] = lY[j - 1];
				lY[j - 1] = lTmp;

				lTmp = lX[j];
				lX[j] = lX[j - 1];
				lX[j - 1] = lTmp;
			}
		}
	}

	// R̗̈ɕāAZs
	if( lY[1] != lY[0] && lY[2] != lY[0] )
	{
		for( i = lY[0]; i < lY[1]; i++ )
		{
			x1 = lX[0] + (lX[1] - lX[0]) * (i - lY[0]) / (lY[1] - lY[0]);
			x2 = lX[0] + (lX[2] - lX[0]) * (i - lY[0]) / (lY[2] - lY[0]);
			LineSubtract( i, x1, x2, DiffX, DiffY, DiffAngle );
		}
	}

	for( i = lY[1]; i < lY[2]; i++ )
	{
			x1 = lX[1] + (lX[3] - lX[1]) * (i - lY[1]) / (lY[3] - lY[1]);
			x2 = lX[0] + (lX[2] - lX[0]) * (i - lY[0]) / (lY[2] - lY[0]);
			LineSubtract( i, x1, x2, DiffX, DiffY, DiffAngle );
	}

	if( lY[3] != lY[1] && lY[3] != lY[2] )
	{
		for( i = lY[2]; i <= lY[3]; i++ )
		{
			x1 = lX[1] + (lX[3] - lX[1]) * (i - lY[1]) / (lY[3] - lY[1]);
			x2 = lX[2] + (lX[3] - lX[2]) * (i - lY[2]) / (lY[3] - lY[2]);
			LineSubtract( i, x1, x2, DiffX, DiffY, DiffAngle );
		}
	}

	m_FvxDisplayEx->DrawImage( m_FvxImage );
}

// Yvs
void CXyq_subDlg::OnExecute() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	IFvSearchResultPtr pSearch_0( __uuidof( FvSearchResult ) );
	IFvSearchResultPtr pSearch_1( __uuidof( FvSearchResult ) );
	IFvLinePtr pLine( __uuidof( FvLine ) );
	IFvPointPtr pNowPoint( __uuidof( FvPoint ) );// Q̃p^[̃T[`ʂ̊_񂾐̒_
	double dNowAngle;// Q̃p^[̃T[`ʂ̊_񂾒̊px
	double dTime;// 
	double dDiffX, dDiffY;// Y
	double dDiffAngle;// P = WA
	double dX_0, dY_0, dX_1, dY_1;
	CString strResult, strTmp;

	m_FvxDisplayEx->ClearOverlay( -1 );

	// ep[^̓Kp
	if( -1 == ApplyChanges() ) return;

	// ԌvJn
	m_FvxPerformanceCounter->StartCount();

	// ͈͂ŕ\
	m_FvxDisplayEx->PutPenColor( RGB(0, 0, 255) );
	m_FvxDisplayEx->DrawData( 0, m_ExeRegion );

	if( 0 == Search( pSearch_0, pSearch_1 ) )
	{
		// T[`ʂ͐Ԃŕ\
		m_FvxDisplayEx->PutPenColor( RGB(255, 0, 0) );

		m_FvxDisplayEx->DrawData( 0, pSearch_0 );
		m_FvxDisplayEx->DrawData( 0, pSearch_1 );

		// Q̃T[`ʂ̒_ƁAxƂ̌p߂
		dX_0 = pSearch_0->Getx();
		dY_0 = pSearch_0->Gety();
		dX_1 = pSearch_1->Getx();
		dY_1 = pSearch_1->Gety();

		pNowPoint->Putx( (dX_0 + dX_1) / 2 ); 
		pNowPoint->Puty( (dY_0 + dY_1) / 2 ); 

		// px߂ۂɁAW͉Ɍƒl傫Ȃ邱ƂɒӂĂ
		// ̂߁A̒l͉EŐɂȂ܂B
		dNowAngle = ArcTan( (dX_1 - dX_0), (dY_1 - dY_0) );

		// Ƃ̃YvZ
		dDiffX = ( pNowPoint->Getx() - m_StandardPoint->Getx() );
		dDiffY = ( pNowPoint->Gety() - m_StandardPoint->Gety() );
		dDiffAngle = ( m_dStandardAngle - dNowAngle );// Ő̒lɂȂ悤vZ

		strResult.Format( "Yw  %.2f\r\nYx  %.2f\r\nYpx  %.2f\r\n",
						   dDiffX, dDiffY, dDiffAngle * 180 / PI );

		Subtract( dDiffX, dDiffY, dDiffAngle );
	}

	// ԌvI
	m_FvxPerformanceCounter->StopCount( &dTime );

	strTmp.Format( "\r\n\r\n : %.2fmsec", dTime );
	strResult += strTmp;
	m_Result.SetWindowText( strResult );

}

void CXyq_subDlg::OnSave() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// R_CAONX̐
	char szFilters[] = "bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName( GetModuleHandle(NULL), szIniFilePath, _MAX_PATH );
	CFileDialog fdlg( FALSE, "bmp", NULL, OFN_PATHMUSTEXIST|OFN_HIDEREADONLY, szFilters, this );
	fdlg.m_ofn.lpstrInitialDir = szIniFilePath;
	fdlg.m_ofn.lpstrTitle = "摜t@Cۑ";

	if( IDOK == fdlg.DoModal() )
	{
		try
		{
			m_FvxFileAccess->PutFilePath( _bstr_t( fdlg.GetPathName() ) );
			m_FvxFileAccess->SaveBitmap( m_FvxImage );
		}
		catch( _com_error )
		{
			long lngErr;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format( "ۑɎs܂Berr_no = %d", lngErr );
			::AfxMessageBox( cStr, MB_ICONWARNING | MB_OK );
			return;
		}
	}
	
}

void CXyq_subDlg::OnDosample() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	long lErr;
	CString cStr, sFilePath;
	TCHAR szIniFilePath[_MAX_PATH];


	// spX擾
	::GetModuleFileName( GetModuleHandle(NULL), szIniFilePath, _MAX_PATH );
	sFilePath = szIniFilePath;
	sFilePath.Replace( "xyq_sub.exe", "sample1.bmp" );

	// }X^摜ǂݍ
	try
	{
		m_FvxFileAccess->PutFilePath( _bstr_t( sFilePath ) );
		m_FvxFileAccess->LoadBitmap( m_FvxImage );
	}
	catch( _com_error )
	{
		m_FvxFileAccess->GetErrReport( &lErr );

		cStr.Format( "sample1.bmpǂݍ߂܂ł" );
		::AfxMessageBox( cStr, MB_ICONWARNING | MB_OK );
		return;
	}

	m_FvxDisplayEx->ClearOverlay( -1 );
	m_FvxDisplayEx->DrawImage( m_FvxImage );
	::AfxMessageBox( "}X^摜ǂݍ", MB_ICONWARNING | MB_OK );
	sFilePath = szIniFilePath;
	sFilePath.Replace( "xyq_sub.exe", "sample1.pat" );

	// p^ǂݍ
	try
	{
		m_FvxPattern->PutLoadPattrenFileName( _bstr_t( sFilePath ) );
		m_FvxPattern->Load();
	}
	catch( _com_error )
	{
		m_FvxPattern->GetErrReport( &lErr );

		cStr.Format( "sample1.patǂݍ߂܂ł" );
		::AfxMessageBox( cStr, MB_ICONWARNING | MB_OK );
		return;
	}

	sFilePath = szIniFilePath;
	sFilePath.Replace( "xyq_sub.exe", "sample2.pat" );

	try
	{
		m_FvxPattern2->PutLoadPattrenFileName( _bstr_t( sFilePath ) );
		m_FvxPattern2->Load();
	}
	catch( _com_error )
	{
		m_FvxPattern2->GetErrReport( &lErr );

		cStr.Format( "sample2.patǂݍ߂܂ł" );
		::AfxMessageBox( cStr, MB_ICONWARNING | MB_OK );
		return;
	}

	// Z̈ݒ
	m_SubRegion->Putxs( 200 );
	m_SubRegion->Putys( 230 );
	m_SubRegion->Putxe( 260 );
	m_SubRegion->Putye( 300 );

	// ʒu
	OnSetStandard();
	::AfxMessageBox( "p^ݒ聕Z̈ݒ聕", MB_ICONWARNING | MB_OK );

	sFilePath = szIniFilePath;
	sFilePath.Replace( "xyq_sub.exe", "sample2.bmp" );

	// 摜ǂݍ
	try
	{
		m_FvxFileAccess->PutFilePath( _bstr_t( sFilePath ) );
		m_FvxFileAccess->LoadBitmap( m_FvxImage );
	}
	catch( _com_error )
	{
		m_FvxFileAccess->GetErrReport( &lErr );

		cStr.Format( "sample2.bmpǂݍ߂܂ł" );
		::AfxMessageBox( cStr, MB_ICONWARNING | MB_OK );
		return;
	}

	m_FvxDisplayEx->ClearOverlay( -1 );
	m_FvxDisplayEx->DrawImage( m_FvxImage );
	::AfxMessageBox( "摜ǂݍ", MB_ICONWARNING | MB_OK );

	// s
	OnExecute();
	::AfxMessageBox( "ACgZs", MB_ICONWARNING | MB_OK );

}

void CXyq_subDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	if(IsIconic() == 0 )
	{
		if ( m_FvxDisplayEx != NULL )
		{

			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );

		}

	}
}
